using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;


namespace WindowsPhoneReMixAzure
{
    public class MainViewModel : INotifyPropertyChanged
    {
        SilverlightReMix.ReMix.ReMixServiceClient client = new SilverlightReMix.ReMix.ReMixServiceClient("BasicHttpBinding_IReMixService");
        public MainViewModel()
        {
            client.GetTalksCompleted += new EventHandler<SilverlightReMix.ReMix.GetTalksCompletedEventArgs>(client_GetTalksCompleted);
            client.GetTalksAsync();
        }

        void client_GetTalksCompleted(object sender, SilverlightReMix.ReMix.GetTalksCompletedEventArgs e)
        {
            Items = e.Result;
            NotifyPropertyChanged("Items");
        }

        public ObservableCollection<SilverlightReMix.ReMix.Talk> Items { get; private set; }

        private string _sampleProperty = "Sample Runtime Property Value";
        /// <summary>
        /// Sample ViewModel property; this property is used in the view to display its value using a Binding
        /// </summary>
        /// <returns></returns>
        public string SampleProperty
        {
            get
            {
                return _sampleProperty;
            }
            set
            {
                _sampleProperty = value;
                NotifyPropertyChanged("SampleProperty");
            }
        }

        /// <summary> Sample ViewModel method; this method is invoked by a Behavior that is associated with it in the View</summary>
        public void SampleMethod()
        {
            SampleProperty = "SampleMethod invoked.";
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            if (null != PropertyChanged)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}